---
title: "Step 6: Create a transaction email template"
component: pingone-api
page_id: pingone-api:workflow-library:pingone-mfa/transaction-approval-using-sms/environment-configuration/step-9-create-a-transaction-sms-template
canonical_url: https://developer.pingidentity.com/pingone-api/workflow-library/pingone-mfa/transaction-approval-using-sms/environment-configuration/step-9-create-a-transaction-sms-template.html
section_ids:
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Step 6: Create a transaction email template

##

   

```none
POST {{apiPath}}/v1/environments/{{envID}}/templates/transaction/contents
```

Use the `POST {{apiPath}}/v1/environments/{{envID}}/templates/transaction/contents` operation to create a transaction template that specifies the transaction information and provides a variable for the one-time passcode.

The body of the request specifies the `locale` property to identify the language for the content. In this use case, the value is the environment's default language.

The `content` property defines the message text the end user receives to complete the transaction. In this use case, the message is `Approve this transfer of ${sum} ${currency} to ${recipient}, by entering this OTP: ${OTP}`. The `${sum}`, `${currency}`, and `${recipient}` variable values in the transaction approval text are encoded in the `request` JWT, which is passed in as a Postman pre-request script on the authorize request.

The `deliveryMethod` property specifies the MFA device type that receives the transaction approval request. In this use case, `EMAIL` is the delivery method.

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
    "locale": "en",
    "subject": "PingOne: transaction approval",
    "variant": "variant_C",
    "body": "Approve this transfer of ${sum} ${currency} to ${recipient}, by entering this OTP: ${OTP}",
    "deliveryMethod": "Email",
    "template": {
        "id": "transaction"
    }
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff '{{apiPath}}/v1/environments/{{envID}}/templates/transaction/contents' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
    "locale": "en",
    "subject": "PingOne: transaction approval",
    "variant": "variant_C",
    "body": "Approve this transfer of ${sum} ${currency} to ${recipient}, by entering this OTP: ${OTP}",
    "deliveryMethod": "Email",
    "template": {
        "id": "transaction"
    }
}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/templates/transaction/contents")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""locale"": ""en""," + "\n" +
@"    ""subject"": ""PingOne: transaction approval""," + "\n" +
@"    ""variant"": ""variant_C""," + "\n" +
@"    ""body"": ""Approve this transfer of ${sum} ${currency} to ${recipient}, by entering this OTP: ${OTP}""," + "\n" +
@"    ""deliveryMethod"": ""Email""," + "\n" +
@"    ""template"": {" + "\n" +
@"        ""id"": ""transaction""" + "\n" +
@"    }" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/templates/transaction/contents"
  method := "POST"

  payload := strings.NewReader(`{
    "locale": "en",
    "subject": "PingOne: transaction approval",
    "variant": "variant_C",
    "body": "Approve this transfer of ${sum} ${currency} to ${recipient}, by entering this OTP: ${OTP}",
    "deliveryMethod": "Email",
    "template": {
        "id": "transaction"
    }
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
POST /v1/environments/{{envID}}/templates/transaction/contents HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "locale": "en",
    "subject": "PingOne: transaction approval",
    "variant": "variant_C",
    "body": "Approve this transfer of ${sum} ${currency} to ${recipient}, by entering this OTP: ${OTP}",
    "deliveryMethod": "Email",
    "template": {
        "id": "transaction"
    }
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"locale\": \"en\",\n    \"subject\": \"PingOne: transaction approval\",\n    \"variant\": \"variant_C\",\n    \"body\": \"Approve this transfer of ${sum} ${currency} to ${recipient}, by entering this OTP: ${OTP}\",\n    \"deliveryMethod\": \"Email\",\n    \"template\": {\n        \"id\": \"transaction\"\n    }\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/templates/transaction/contents")
  .method("POST", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/templates/transaction/contents",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "locale": "en",
    "subject": "PingOne: transaction approval",
    "variant": "variant_C",
    "body": "Approve this transfer of ${sum} ${currency} to ${recipient}, by entering this OTP: ${OTP}",
    "deliveryMethod": "Email",
    "template": {
      "id": "transaction"
    }
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/v1/environments/{{envID}}/templates/transaction/contents',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "locale": "en",
    "subject": "PingOne: transaction approval",
    "variant": "variant_C",
    "body": "Approve this transfer of ${sum} ${currency} to ${recipient}, by entering this OTP: ${OTP}",
    "deliveryMethod": "Email",
    "template": {
      "id": "transaction"
    }
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/templates/transaction/contents"

payload = json.dumps({
  "locale": "en",
  "subject": "PingOne: transaction approval",
  "variant": "variant_C",
  "body": "Approve this transfer of ${sum} ${currency} to ${recipient}, by entering this OTP: ${OTP}",
  "deliveryMethod": "Email",
  "template": {
    "id": "transaction"
  }
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/templates/transaction/contents');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "locale": "en",\n    "subject": "PingOne: transaction approval",\n    "variant": "variant_C",\n    "body": "Approve this transfer of ${sum} ${currency} to ${recipient}, by entering this OTP: ${OTP}",\n    "deliveryMethod": "Email",\n    "template": {\n        "id": "transaction"\n    }\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/templates/transaction/contents")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "locale": "en",
  "subject": "PingOne: transaction approval",
  "variant": "variant_C",
  "body": "Approve this transfer of \${sum} \${currency} to \${recipient}, by entering this OTP: \${OTP}",
  "deliveryMethod": "Email",
  "template": {
    "id": "transaction"
  }
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n    \"locale\": \"en\",\n    \"subject\": \"PingOne: transaction approval\",\n    \"variant\": \"variant_C\",\n    \"body\": \"Approve this transfer of ${sum} ${currency} to ${recipient}, by entering this OTP: ${OTP}\",\n    \"deliveryMethod\": \"Email\",\n    \"template\": {\n        \"id\": \"transaction\"\n    }\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/templates/transaction/contents")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

201 Created

```json
{
    "_links": {
        "self": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/templates/transaction/contents/34ad16dd-9041-4b98-83f8-eb94b015df55"
        },
        "template": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/templates/transaction"
        },
        "language": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/languages/5673ed79-516c-43ee-bf11-0d8df7e6fee8"
        },
        "environment": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
        }
    },
    "id": "34ad16dd-9041-4b98-83f8-eb94b015df55",
    "environment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "createdAt": "2026-04-22T20:11:35.493Z",
    "updatedAt": "2026-04-22T20:11:35.493Z",
    "locale": "en",
    "variant": "variant_C",
    "template": {
        "id": "transaction"
    },
    "subject": "PingOne: transaction approval",
    "body": "Approve this transfer of ${sum} ${currency} to ${recipient}, by entering this OTP: ${OTP}",
    "deliveryMethod": "Email",
    "default": false
}
```
